<?php

namespace App\Jobs;

use Log;
use App\Jobs\Job;
use Illuminate\Queue\SerializesModels;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Artisan;

class CatalogScan extends Job implements ShouldQueue
{
	use InteractsWithQueue, SerializesModels;

	// Our object
	private $o = NULL;

	/**
	 * Create a new job instance.
	 *
	 * @return void
	 */
	public function __construct(\App\Model\Abstracted\Catalog $o)
	{
		$this->o = $o;
	}

	/**
	 * Execute the job.
	 *
	 * @return void
	 */
	public function handle()
	{
		Log::info(sprintf('%s: Scanning [%s|%s]',__METHOD__,$this->o->objecttype(),$this->o->id));
		Artisan::call('catalog:scan',['type'=>$this->o->objecttype(),'id'=>$this->o->id]);
	}
}
